<?php 

require_once 'class-amazingcarousel-model.php';
require_once 'class-amazingcarousel-view.php';

class AmazingCarousel_Controller {

	private $view, $model;

	function __construct() {

		$this->model = new AmazingCarousel_Model($this);	
		$this->view = new AmazingCarousel_View($this);
	}

	function add_new() {
		
		$this->view->print_add_new();
	}
	
	function show_carousels() {
		
		$this->view->print_carousels();
	}
	
	function view_carousel()
	{
		$this->view->view_carousel();
	}
	
	function install_carousel($zipfile, $id) {
		
		return $this->model->install_carousel($zipfile, $id);
	}
	
	function generate_body_code($id) {
		
		return $this->model->generate_body_code($id);
	}
	
	function get_list_data() {
		
		return $this->model->get_list_data();
	}
	
	function delete_carousel($id)
	{
		return $this->model->delete_carousel($id);
	}
	
	function activation_handler()
	{
		if ( !$this->model->is_db_table_exists() )
			$this->model->install_carousel_from_folder( AMAZINGCAROUSEL_PATH, -1);
	}
}