<?php 

require_once 'class-amazingcarousel-list-table.php';

class AmazingCarousel_View {

	private $controller;
	private $list_table;
	
	function __construct($controller) {
		
		$this->controller = $controller;
	}
	
	function print_add_new() {
		
		if ( !empty($_POST) && (isset($_POST['amzingcarousel-upload']) || isset($_POST['amzingcarousel-upload-url'])) && wp_verify_nonce($_POST['amazingcarousel-nonce'],'amazingcarousel-add-new-add-new') )
		{	
			if ( isset($_POST['amzingcarousel-upload']) )	
			{	
				if ( !isset($_FILES['amazingcarousel-zip']) || ($_FILES["amazingcarousel-zip"]["error"] > 0) )
				{
					if ($_FILES["amazingcarousel-zip"]["error"] == 1)
						echo '<div class="error"><p>' . __('The uploaded file exceeds the upload_max_filesize directive in php.ini', 'amazingcarousel')  . '</p></div>';
					else
						echo '<div class="error"><p>' . __('Please select a ZIP file created with Amazing Carousel', 'amazingcarousel')  . '</p></div>';
				}
				else
				{		
					$uploadfile = wp_handle_upload($_FILES['amazingcarousel-zip'], array(
							'test_form' => false,
							'mimes' => array('zip' => 'application/zip')
					));
					
					if ( isset($uploadfile['error']) )
					{
						echo '<div class="error"><p>' . esc_attr($uploadfile['error'])  . '</p></div>';
					}
					else
					{
						$id = ( isset($_POST['amazingcarousel-replace']) && ($_POST['amazingcarousel-replace'] == 'yes') && isset($_POST['amazingcarousel-replace-id']) ) ? ($_POST['amazingcarousel-replace-id']) : -1;
						$ret = $this->controller->install_carousel($uploadfile['file'], $id);
						if ( is_wp_error($ret) )
						{
							echo '<div class="error"><p>' . $ret->get_error_message()  . '</p></div>';
						}
						else
						{		
							if ( $ret["new"] )
								echo '<div class="error"><p>This is a new version Amazing Carousel WordPress Plugin. In addition to adding the Carousel here, you also need to update the Plugin itself. Fore more inforamtion, visit <a href="http://amazingcarousel.com/how-to-update-amazing-carousel-wordpress-plugin/" target="_blank">How to update Amazing Carousel WordPress Plugin</a>.</p></div>';
															
							echo '<div class="updated"><p>The carousel is successfully installed. &nbsp;&nbsp;<a href="?page=amazingcarousel_view_carousel&carouselid=' . $ret["id"] . '">View The Carousel</a></p></div>';
							echo '<div class="updated"><p> To embed the carousel into your page, use shortcode <strong>[amazingcarousel id="' . $ret["id"] . '"]</strong></p></div>';
							echo '<div class="updated"><p> To embed the carousel into your template, use php code <strong>' . esc_attr('<?php echo do_shortcode(\'[amazingcarousel id="' . $ret["id"] . '"]\'); ?>') . '</strong></p></div>';						
						}
					}
				}
			}
			else if ( isset($_POST['amzingcarousel-upload-url']) )
			{				
				if ( !isset($_POST['amazingcarousel-zip-url']) || strlen($_POST['amazingcarousel-zip-url']) == 0)	
				{
					echo '<div class="error"><p>' . __('Please specify a URL of ZIP file created with Amazing Carousel', 'amazingcarousel')  . '</p></div>';
				}	
				else
				{
					$accepted_status_codes = array( 200, 301, 302 );
					$response = wp_remote_head( $_POST['amazingcarousel-zip-url'] );
					if ( is_wp_error( $response ) || !in_array( wp_remote_retrieve_response_code( $response ), $accepted_status_codes ) ) {
						echo '<div class="error"><p>' . __('The specified URL does not exist', 'amazingcarousel')  . '</p></div>';
					}
					else
					{				
						$uploadfile = fopen($_POST['amazingcarousel-zip-url'], "r");
						if ( !$uploadfile )
						{
							echo '<div class="error"><p>' . __('The specified URL does not exist', 'amazingcarousel')  . '</p></div>';
						}
						else
						{						
							$uploads = wp_upload_dir();
							$zipfile = $uploads['basedir'] . '/amazingcarousel/amazingcarousel-url-upload.zip';
							
							while ( !feof($uploadfile) )
							{
								file_put_contents($zipfile, fread($uploadfile, 4096), FILE_APPEND);
							}
							fclose($uploadfile);
							
							$id = ( isset($_POST['amazingcarousel-replace']) && ($_POST['amazingcarousel-replace'] == 'yes') && isset($_POST['amazingcarousel-replace-id']) ) ? ($_POST['amazingcarousel-replace-id']) : -1;
							$ret = $this->controller->install_carousel($zipfile, $id);
							if ( is_wp_error($ret) )
							{
								echo '<div class="error"><p>' . $ret->get_error_message()  . '</p></div>';
							}
							else
							{
								if ( $ret["new"] )
									echo '<div class="error"><p>This is a new version Amazing Carousel WordPress Plugin. In addition to adding the carousel here, you also need to update the Plugin itself. Fore more inforamtion, visit <a href="http://amazingcarousel.com/how-to-update-amazing-carousel-wordpress-plugin/" target="_blank">How to update Amazing Carousel WordPress Plugin</a>.</p></div>';
									
								echo '<div class="updated"><p>The carousel is successfully installed. &nbsp;&nbsp;<a href="?page=amazingcarousel_view_carousel&carouselid=' . $ret["id"] . '">View The Carousel</a></p></div>';
								echo '<div class="updated"><p> To embed the carousel into your page, use shortcode <strong>[amazingcarousel id="' . $ret["id"] . '"]</strong></p></div>';
								echo '<div class="updated"><p> To embed the carousel into your template, use php code <strong>' . esc_attr('<?php echo do_shortcode(\'[amazingcarousel id="' . $ret["id"] . '"]\'); ?>') . '</strong></p></div>';
							}
						}
					}
				}
			}	
		}
		?>
		<div class="wrap">
			<div id="icon-amazingcarousel" class="icon32"><br /></div>
			
			<h2><?php _e( 'Add New Carousel', 'amazingcarousel' ); ?> <a href="<?php echo admin_url('admin.php?page=amazingcarousel_show_carousels'); ?>" class="add-new-h2">Show All Carousels</a></h2>
			
			<h3><?php _e( 'Install the ZIP file created with <a href="http://amazingcarousel.com" target="_blank">Amazing Carousel</a>', 'amazingcarousel' ); ?></h3>
						
			<form id="form-amazingcarousel-add-new" method="post" enctype="multipart/form-data"> 
				<ul>
					<li>
						<h4><?php _e( 'Upload ZIP file:', 'amazingcarousel' ); ?></h4>
						<input type="file" id="amazingcarousel-zip" name="amazingcarousel-zip" />
						<input id="amzingcarousel-upload" name="amzingcarousel-upload" type="submit" class="button" value="<?php esc_attr_e('Install', 'amazingcarousel') ?>" />
					</li> 
					<li>
						<h4><?php _e( 'Or install from URL:', 'amazingcarousel' ); ?></h4>
						<p><?php _e( 'If the ZIP file is too large, you can upload the file to your web server via FTP, then install the ZIP file from URL.', 'amazingcarousel' ); ?></p>
						<input type="text" id="amazingcarousel-zip-url" name="amazingcarousel-zip-url" size="35" />
						<input id="amzingcarousel-upload-url" name="amzingcarousel-upload-url" type="submit" class="button" value="<?php esc_attr_e('Install', 'amazingcarousel') ?>" />
						<p><strong><?php _e( '* Installing may take a while depending on the size of your ZIP file. Please be patient.', 'amazingcarousel' ); ?></strong></p>
					</li> 
					<li>
						<input type="checkbox" name="amazingcarousel-replace" value="yes"><?php esc_attr_e('Replace an existing carousel', 'amazingcarousel') ?>:&nbsp;
						<select name="amazingcarousel-replace-id">
							<?php 
							global $wpdb;
							$table_name = $wpdb->prefix . "amazingcarousel";
							$carousel_rows = $wpdb->get_results( "SELECT * FROM $table_name", ARRAY_A);						
							if ( $carousel_rows )
							{
								foreach ( $carousel_rows as $row )
									echo '<option value="' . $row['id'] . '">' . $row['id'] . ' : ' . $row['name'] . '</option>';
							}
							?>
						</select>
					</li>
	  			</ul>
	  			<?php wp_nonce_field('amazingcarousel-add-new-add-new','amazingcarousel-nonce'); ?>
	  		</form>              
		</div>
		<?php
	}
	
	function print_carousels() {
		
		?>
		<div class="wrap">
		<div id="icon-amazingcarousel" class="icon32"><br /></div>
			
		<h2><?php _e( 'Installed Carousels', 'amazingcarousel' ); ?> <a href="<?php echo admin_url('admin.php?page=amazingcarousel_add_new'); ?>" class="add-new-h2">Add New</a> </h2>
		
		<?php $this->process_delete_action(); ?>
		
		<form id="carousel-list-table" method="post">
		<input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
		<?php 
		
		if ( !is_object($this->list_table) )
			$this->list_table = new AmazingCarousel_List_Table($this);
		$this->list_table->list_data = $this->controller->get_list_data();
		$this->list_table->prepare_items();
		$this->list_table->display();		
		?>								
        </form>
        
		</div>
		<?php
	}
	
	function process_delete_action()
	{
		$deleted = 0;
		
		if ( isset($_REQUEST['action']) && ($_REQUEST['action'] == 'delete') && isset( $_REQUEST['carouselid'] ) )
		{
			if ( is_array( $_REQUEST['carouselid'] ) )
			{
				foreach( $_REQUEST['carouselid'] as $id)
				{
					$ret = $this->controller->delete_carousel($id);
					if ($ret > 0)
						$deleted += $ret;
				}
			}
			else
			{
				$deleted = $this->controller->delete_carousel( $_REQUEST['carouselid'] );
			}
		}
	
		if ($deleted > 0)
		{
			echo '<div class="updated"><p>';
			printf( _n('%d carousel deleted.', '%d carousels deleted.', $deleted), $deleted );
			echo '</p></div>';
		}
		
	}
	
	function view_carousel()
	{
		if ( !isset( $_REQUEST['carouselid'] ) )
			return;
		
		?>
		<div class="wrap">
		<div id="icon-amazingcarousel" class="icon32"><br /></div>
					
		<h2><?php _e( 'View Carousel', 'amazingcarousel' ); ?> <a href="<?php echo admin_url('admin.php?page=amazingcarousel_show_carousels'); ?>" class="add-new-h2">Show All Carousels</a> <a href="<?php echo admin_url('admin.php?page=amazingcarousel_add_new'); ?>" class="add-new-h2">Add New</a> </h2>
		
		<div class="updated"><p style="text-align:center;"> To embed the carousel into your page, use shortcode <strong><?php echo esc_attr('[amazingcarousel id="' . $_REQUEST['carouselid'] . '"]'); ?></strong></p></div>

		<div class="updated"><p style="text-align:center;"> To embed the carousel into your template, use php code <strong><?php echo esc_attr('<?php echo do_shortcode(\'[amazingcarousel id="' . $_REQUEST['carouselid'] . '"]\'); ?>'); ?></strong></p></div>
		
		<?php
		echo $this->controller->generate_body_code( $_REQUEST['carouselid'] ); 
		?>	 

		</div>
		<?php
	}
		
}